package com.adventurer_engine.client.event;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import ats;
import atv;
import bdi;
import bex;
import com.adventurer_engine.client.key.KeyInputEvent;
import com.adventurer_engine.client.key.KeyTickHandler;
import com.adventurer_engine.common.CommonConfig;
import com.adventurer_engine.network.client2server.RenewDurationDelayPacket;
import com.adventurer_engine.network.client2server.RequestSlideStep;
import com.adventurer_engine.network.client2server.SwitchAmmoPacket;
import cpw.mods.fml.common.network.PacketDispatcher;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.event.ForgeSubscribe;

@SideOnly(Side.CLIENT)
public class ClientEventLoader {
  private long lastTime;
  
  public ClientEventLoader() {
    this.lastTime = 0L;
    MinecraftForge.EVENT_BUS.register(this);
  }
  
  private static final RenewDurationDelayPacket renewDurationPacket = new RenewDurationDelayPacket();
  
  @ForgeSubscribe
  public void actionSlideStep(KeyInputEvent event) {
    atv mc = atv.w();
    if (!mc.A)
      return; 
    ats currentKey = event.key;
    if (currentKey.equals(KeyTickHandler.keys[0])) {
      handleSlideStep(event);
    } else if (currentKey.equals(KeyTickHandler.keys[1])) {
      handleAmmoSwitch(event, true);
    } else if (currentKey.equals(KeyTickHandler.keys[2])) {
      handleAmmoSwitch(event, false);
    } else if (currentKey.equals((atv.w()).u.R) || currentKey.equals((atv.w()).u.S)) {
      PacketDispatcher.sendPacketToServer(renewDurationPacket.makePacket());
    } 
  }
  
  private static final SwitchAmmoPacket switch_up = new SwitchAmmoPacket(true);
  
  private static final SwitchAmmoPacket switch_down = new SwitchAmmoPacket(false);
  
  private void handleAmmoSwitch(KeyInputEvent event, boolean isUp) {
    if (event.keyUp())
      return; 
    if (isUp) {
      PacketDispatcher.sendPacketToServer(switch_up.makePacket());
    } else {
      PacketDispatcher.sendPacketToServer(switch_down.makePacket());
    } 
  }
  
  private void handleSlideStep(KeyInputEvent event) {
    if (!CommonConfig.enableSlideStep)
      return; 
    atv mc = atv.w();
    bdi bdi = mc.h;
    if (bdi.bI().a() == 0)
      return; 
    if (event.keyUp())
      return; 
    long timeNow = System.currentTimeMillis();
    int deley = 500;
    if (timeNow - this.lastTime >= deley) {
      double theta, velocity = 1.2D;
      if (!((bex)bdi).F)
        velocity /= 2.5D; 
      if (((bex)bdi).z == 0.0D && ((bex)bdi).x == 0.0D) {
        theta = -bdi.ap() * Math.PI / 180.0D;
      } else if (((bex)bdi).z == 0.0D) {
        theta = (((bex)bdi).x > 0.0D) ? 2.356194490192345D : 1.5707963267948966D;
      } else if (((bex)bdi).x == 0.0D) {
        theta = (((bex)bdi).z > 0.0D) ? 0.0D : Math.PI;
      } else {
        theta = 1.5707963267948966D - Math.atan2(((bex)bdi).z, -((bex)bdi).x);
      } 
      double x = (float)(-velocity * Math.sin(theta));
      double z = (float)(velocity * Math.cos(theta));
      bdi.g(x, 0.0D, z);
      PacketDispatcher.sendPacketToServer((new RequestSlideStep()).makePacket());
      this.lastTime = timeNow;
    } 
  }
}
